package admin

import (
    "fmt"
    "net/http"
    "strings"

    "arimelody-web/model"
    "arimelody-web/controller"
)

func serveTrack(app *model.AppState) http.Handler {
    return http.HandlerFunc(func(w http.ResponseWriter, r *http.Request) {
        slices := strings.Split(r.URL.Path[1:], "/")
        id := slices[0]
        track, err := controller.GetTrack(app.DB, id)
        if err != nil {
            fmt.Printf("Error rendering admin track page for %s: %s\n", id, err)
            http.Error(w, http.StatusText(http.StatusInternalServerError), http.StatusInternalServerError)
            return
        }
        if track == nil {
            http.NotFound(w, r)
            return
        }

        releases, err := controller.GetTrackReleases(app.DB, track.ID, true)
        if err != nil {
            fmt.Printf("FATAL: Failed to pull releases for %s: %s\n", id, err)
            http.Error(w, http.StatusText(http.StatusInternalServerError), http.StatusInternalServerError)
            return
        }

        type TrackResponse struct {
            Session     *model.Session
            Track       *model.Track
            Releases    []*model.Release
        }

        session := r.Context().Value("session").(*model.Session)

        err = trackTemplate.Execute(w, TrackResponse{
            Session: session,
            Track: track,
            Releases: releases,
        })
        if err != nil {
            fmt.Printf("Error rendering admin track page for %s: %s\n", id, err)
            http.Error(w, http.StatusText(http.StatusInternalServerError), http.StatusInternalServerError)
        }
    })
}

